﻿using System;
using System.Collections.Generic;

namespace Workspace
{
    public class Entity<TIdentity> where TIdentity : struct
    {
        public TIdentity Id { get; set; }
    }

    public class Customer : Entity<int>
    {
        private IList<Order> _orders = new List<Order>();
        public string Name { get; set; }

        public IList<Order> Orders
        {
            get { return _orders; }
            set { _orders = value; }
        }

        public override string ToString()
        {
            return string.Format("Customer with Id: {0}", Id);
        }
    }

    public class Order : Entity<int>
    {
        private IList<Item> _items = new List<Item>();
        public string OrderNumber { get; set; }

        public IList<Item> Items
        {
            get { return _items; }
            set { _items = value; }
        }
    }

    public class Item : Entity<Guid>
    {
        public int Quantity { get; set; }
    }


    public class Repository<TEntity, TIdentity>
        where TEntity : Entity<TIdentity>, new()
        where TIdentity : struct
    {
        public void Save(TEntity thing)
        {
            //do something to save here!
        }

        public void Delete(TEntity thing)
        {
            //do something to delete here!
        }

        public TEntity Get(TIdentity id)
        {
            //use id to retrieve the right instance
            return null;
        }

        public TEntity New(TIdentity id)
        {
            return new TEntity() { Id = id };
        }

    }
}