﻿using System;
using System.Collections;
using System.Collections.Generic;
using NUnit.Framework;

namespace Workspace
{
    [TestFixture]
    public class Tests
    {
        [Test]
        public void PlayinngWithCustomers()
        {
            var list = new ArrayList();

            var customer1 = new Customer() { Id = 1 };
            var customer2 = new Customer() { Id = 2 };

            list.Add(customer1);
            list.Add(customer2);

            Assume.That(list, Has.Member(customer1));
            Assume.That(list, Has.Member(customer2));

            var retrievedCustomer1 = (Customer)list[0];
            var retrievedCustomer2 = (Customer)list[1];

            Assert.That(retrievedCustomer1, Is.EqualTo(customer1));
            Assert.That(retrievedCustomer2, Is.EqualTo(customer2));

            list.Add("hello");
            var badCustomer = (Customer)list[2];

        }

        [Test]
        public void CanSaveCustomer()
        {
            var repository = new Repository<Customer, int>();

            var customer = new Customer() { Id = 1 };

            repository.Save(customer);

            Customer customer1 = repository.Get(1);
        }

        [Test]
        public void CanSaveJustAboutAnything()
        {
            var repository = new Repository<Item, Guid>();

            repository.Save(new Item());

            Item item = repository.Get(Guid.NewGuid());
        }

        [Test]
        public void ProblemWithRepository()
        {
            
        }
    }


}